"""
Singleton class for interacting with the OpenAI Codex model
for the purpose of function implementation generation.
"""

import openai
import os
import re

from asts import AST, ASTLanguage, RootAST, FunctionAST
from collections import OrderedDict
from typing import Dict, Final, List, Text, Tuple

from function_generator.ast_utils import (
    contains_error_nodes,
    function_docstring,
    qualified_name,
)
from function_generator.text import (
    fixup_multiline_strings,
    has_trailing_newlines,
    strip_empty_lines,
)

CodexModelCacheType = Dict[Tuple[str, str], Dict[str, List[AST]]]


class CodexModel:
    """
    Base class for interacting with the OpenAI Codex model.
    """

    DEFAULT_ENGINE_CHOICES: Final[List[str]] = ["davinci-codex", "cushman-codex"]
    DEFAULT_ENGINE: Final[str] = DEFAULT_ENGINE_CHOICES[0]
    DEFAULT_TEMPERATURE: Final[float] = 0.0
    DEFAULT_TOP_P: Final[float] = 1.0
    DEFAULT_MAX_TOKENS: Final[int] = 64

    def __init__(
        self,
        engine: str = DEFAULT_ENGINE,
        temperature: float = DEFAULT_TEMPERATURE,
        top_p: float = DEFAULT_TOP_P,
        max_tokens: int = DEFAULT_MAX_TOKENS,
    ):
        """
        Create a CodexModel object for performing queries.

        :param engine: codex engine to utilize in generation
        :param temperature: sampling temperature to use; higher values imply
            model taking more risk
        :param top_p: nucleus sampling; model considers tokens with top_p
            probability mass
        :param max_tokens: number of tokens to generate in each completion requst
        """
        self.engine: str = engine
        self.temperature: float = temperature
        self.top_p: float = top_p
        self.max_tokens: int = max_tokens

        if os.getenv("OPENAI_API_KEY"):
            openai.api_key = os.getenv("OPENAI_API_KEY")
        else:
            raise RuntimeError("OPENAI_API_KEY environment variable must be set.")

    def query(self, script: RootAST, prototype: FunctionAST) -> List[FunctionAST]:
        """
        Query the OpenAI Codex model to generate an implementation for PROTOTYPE from
        its signature and documentation string.

        :param script: root AST of the script containing prototype
        :param prototype: function prototype AST containing a function signature
            and documentation string to generate an implementation for
        :return: implementation generated by the codex engine
        """

        def build_import_lines(imports: List[str]) -> List[Text]:
            """
            Return a list of python import/import-from statements corresponding
            to the given list of IMPORTS available to the function prototype.
            """
            HYPOTHESIS_IMPORT_RE = r"^hypothesis\.?"
            result = []

            for imprt in imports:
                if imprt and not re.match(HYPOTHESIS_IMPORT_RE, imprt[0]):
                    if len(imprt) == 1:
                        result.append(f"import {imprt[0]}")
                    elif len(imprt) == 2:
                        result.append(f"import {imprt[0]} as {imprt[1]}")
                    elif len(imprt) == 3:
                        result.append(f"from {imprt[0]} import {imprt[2]}")

            return result

        def build_prompt(
            import_lines: List[Text],
            prototype_lines: List[Text],
            result_lines: List[Text] = [],
        ) -> Text:
            """
            Build a OpenAI Codex prompt to create an implementation for
            PROTOTYPE_LINES with, optionally, RESULT_LINES to build upon
            and IMPORT_LINES available for the implementation.
            """
            prompt = ["# Python3"] + import_lines + prototype_lines + result_lines
            prompt = strip_empty_lines(prompt)
            prompt = fixup_multiline_strings(prompt)
            return "\n".join(prompt)

        def is_continuation_of_line(
            num_requests: int,
            response_line: int,
            result_lines: List[Text],
        ) -> bool:
            """
            Return TRUE if the current RESPONSE_LINE from the Codex model
            being processed is a continuation of the last line in RESULT_LINES.
            """
            # Return true if the number of requests made to the OpenAI model is
            # greater than zero, we are processing the first line in the
            # current response, and the last line of results is partially
            # populated.
            return num_requests > 0 and response_line == 0 and result_lines[-1]

        def is_implementation_line(line: Text, result_lines: List[Text]) -> bool:
            """
            Return TRUE if LINE should be included in the RESULT_LINES as part
            of the implementation.
            """

            FUNCTION_NAME_RE = r"^def\s+([A-Za-z0-9][A-Za-z0-9_]*)\s*[(]"
            result_text = "\n".join(result_lines)

            def is_top_level_ast(line: Text) -> bool:
                """
                Return TRUE if LINE from an OpenAI Codex response represents
                a new, top-level AST outside the current function.
                """
                return line.strip() and line.strip() == line

            def is_incomplete_function_signature(line) -> bool:
                """
                Return TRUE if LINE is an incomplete function signature.
                """
                return line.startswith("def") and not re.search(FUNCTION_NAME_RE, line)

            def function_calls(text: Text) -> List[str]:
                """
                Return the names of function calls in TEXT.
                """
                calls = AST.from_string(text, ASTLanguage.Python).call_asts()
                calls = {call.call_function().source_text for call in calls}
                return list(calls)

            def is_callsite_definition(line: Text, result_text: Text) -> bool:
                """
                Return TRUE if LINE is the start of a function definition and
                the function is called in RESULT_TEXT.
                """
                calls = function_calls(result_text)
                function_name = re.search(FUNCTION_NAME_RE, line)
                function_name = function_name.group(1) if function_name else None
                return function_name in calls

            # Add the line to the result if (1) this is not a top-level AST
            # or (2) this is an incomplete function signature or the signature
            # of a function called in the current result text.
            top_level = is_top_level_ast(line)
            incomplete = top_level and is_incomplete_function_signature(line)
            call_definition = top_level and is_callsite_definition(line, result_text)
            return not top_level or (incomplete or call_definition)  # (1) or (2)

        def build_codex_function_implementation(
            prototype: FunctionAST,
        ) -> List[FunctionAST]:
            """
            Continuously query the OpenAI codex model to build an implementation
            for PROTOTYPE, a function prototype with documentation string.
            """
            MAX_REQUESTS = 15

            result_lines = []
            import_lines = build_import_lines(prototype.imports(script))
            prototype_lines = prototype.source_text.splitlines()

            continue_requests = True

            for i in range(0, MAX_REQUESTS):
                # Query the model to generate a completion based on the
                # prototype and current implementation result.
                response = openai.Completion.create(
                    prompt=build_prompt(import_lines, prototype_lines, result_lines),
                    engine=self.engine,
                    temperature=self.temperature,
                    top_p=self.top_p,
                    max_tokens=self.max_tokens,
                )

                # Retrieve the lines of text returned from the model.
                response_lines = response.get("choices", []) if response else []
                response_lines = response_lines[0] if response_lines else []
                response_lines = response_lines["text"] if response_lines else []
                response_lines = response_lines.splitlines() if response_lines else []

                # Keep adding lines to the result until we find a line that is not
                # part of the implementation.
                for j, line in enumerate(response_lines):
                    # Special case, check for the continuation of a partially-completed
                    # line.  If so, continue processing after appending rest of the
                    # line to the existing result.
                    if is_continuation_of_line(i, j, result_lines):
                        line = result_lines.pop() + line

                    if is_implementation_line(line, result_lines):
                        result_lines.append(line)
                    else:
                        continue_requests = False
                        break

                # Break out of the loop if no response was returned or we found
                # a line that is not part of the implementation.
                if not strip_empty_lines(response_lines) or not continue_requests:
                    break

            # Parse the result into an AST.
            text = "\n".join(prototype_lines + strip_empty_lines(result_lines))
            root = AST.from_string(text, ASTLanguage.Python)

            # Check if the implementation is still incomplete or contains errors.
            # If the result is still incomplete, the model is likely generating
            # a large amount of "garbage" code unrelated to the original request,
            # which we do not want to give back to the user.  Similarly, if the
            # result contain python errors we do not want to return it.
            is_incomplete = i == MAX_REQUESTS - 1
            is_incomplete = is_incomplete and not has_trailing_newlines(result_lines)
            contains_errors = contains_error_nodes(root)

            # Return the implementation functions if the result is not incomplete
            # or containing error nodes.
            functions = [c for c in root.children if isinstance(c, FunctionAST)]
            functions = functions if not is_incomplete and not contains_errors else []
            return functions

        return build_codex_function_implementation(prototype)


class CachingCodexModel(CodexModel):
    """
    Derived class for interacting with the OpenAI Codex model with caching of results.
    """

    MAX_CACHE_SIZE: Final[int] = 4096

    def __init__(self, *args, **kwargs):
        """
        Create a CodexModel object for performing queries with results caching.
        """
        super(CachingCodexModel, self).__init__(*args, **kwargs)
        self.cache: CodexModelCacheType = OrderedDict()

    def query(
        self,
        uri: str,
        script: RootAST,
        prototype: FunctionAST,
    ) -> List[FunctionAST]:
        """
        Query the OpenAI Codex model to generate an implementation for PROTOTYPE from
        its signature and documentation string.

        :param uri: URI of the file containing prototype
        :param script: root AST of the script containing prototype
        :param prototype: function prototype AST containing a function signature
            and documentation string to generate an implementation for
        :return: implementation generated by the codex engine
        """
        function_key = (uri, qualified_name(script, prototype))
        docstring = function_docstring(prototype).source_text

        self._cache_evict()

        function_cache = self.cache.setdefault(function_key, OrderedDict())
        if docstring not in function_cache:
            # The generated implementation is not in the cache, call the parent method.
            function_cache[docstring] = super(CachingCodexModel, self).query(
                script, prototype
            )
        else:
            # Keep the function_cache sorted by least recently used.
            function_cache.move_to_end(docstring)

        return function_cache[docstring]

    def is_last_query(
        self,
        uri: str,
        script: RootAST,
        prototype: FunctionAST,
    ) -> bool:
        """
        Return TRUE if the most recent implementation generated by the OpenAI
        Codex model for PROTOTYPE used the documentation string currently present.

        :param uri: URI of the file containing prototype
        :param script: root AST of the script containing prototype
        :param prototype: function prototype AST containing a function signature
            and documentation string to generate an implementation for
        :return: true if the most recent implementation generated for prototype
            was created based on the current documentation string
        """
        docstring = function_docstring(prototype)
        docstring = docstring.source_text if docstring else None
        function_key = (uri, qualified_name(script, prototype))
        docstring_queries = list(self.cache.get(function_key, {}).keys())
        return docstring_queries and docstring_queries[-1] == docstring

    def is_function_in_cache(
        self,
        uri: str,
        script: RootAST,
        function: FunctionAST,
    ) -> bool:
        """
        Return TRUE if the OpenAI Codex model has generated an implementation
        for FUNCTION.

        :param uri: URI of the file containing prototype
        :param script: root AST of the script containing prototype
        :param function: function AST
        :return: true if a function implementation has been generated for prototype
        """
        function_key = (uri, qualified_name(script, function))
        return function_key in self.cache

    def cache_size(self) -> int:
        """
        Return the size of the cache.
        """
        size = 0
        for function_key in self.cache:
            for docstring in self.cache[function_key]:
                size += 1
        return size

    def _cache_evict(self):
        """
        Evict items from the cache from first to last insertion until the cache size
        is less than half of maximum.
        """
        if self.cache_size() > CachingCodexModel.MAX_CACHE_SIZE:
            while self.cache_size() > CachingCodexModel.MAX_CACHE_SIZE / 2:
                function_key = list(self.cache.keys())[0]
                self.cache.pop(function_key)
